const {
  existsSync,
  readFileSync,
  writeFileSync,
  appendFileSync,
  createWriteStream,
} = require("fs");
const { EOL } = require("os");

let rxLines2 = `\r\nimport "./src/pluugins/index.js"`;
// let rxLines3 = `\r\nimport App from "./App.vue";\r\n `;
//添加文件
let pluginFile = {
  "./src/plugins/index.js": "./templates/src/plugins/index.js",
  "./src/components/RxExample.vue": "./templates/src/components/RxExample.vue",
};
module.exports = (api, options, rootOptions) => {
  // 依赖包
  api.extendPackage({
    dependencies: {
      rxjs: "^6.3.3",
      "vue-rx": "^6.1.1",
    },
  });

  // main写入
  api.afterInvoke(() => {
    const contentMain = readFileSync(api.resolve(api.entryFile), {
      encoding: "utf-8",
    });
    const lines = contentMain.split(/\r?\n/g); //内容以换行符为条件截取

    // const renderIndex = lines.findIndex((line) =>
    //   line.match(/import Vue from "vue";/)
    // );
    // console.log("++++++++++++++renderIndex++++++++++++++++", lines);
    // lines[renderIndex + 1] = `\r\n`;
    // lines[renderIndex + 1] = `import "./src/pluugins/index.js"`;
    // lines[renderIndex + 2] = rxLines3;
    // writeFileSync(api.resolve(api.entryFile), lines.join(EOL), {
    //   encoding: "utf-8",
    // });
    // appendFileSync(api.resolve(api.entryFile), lines.join(EOL), "UTF-8", {
    //   flags: "a+",
    // });
    let wf = createWriteStream(api.resolve(api.entryFile));
    let rxLines2 = `import "./plugins/index.js"`;
    wf.write(rxLines2 + "\r\n", "utf-8");
    console.log("-----------------lines-----------------", lines);
    lines.forEach((v) => {
      wf.write(v + "\r\n", "utf-8");
    });
  });
  api.render({
    ...pluginFile,
  });
  // 模板渲染
  //   if (options.addExample) {

  //   }
};
